<?php

class Criteo {

    static protected $config = null;

    /**
     * Init la config de criteo
     *
     * @param array $config :
     *  - position : tracking_footer | tracking_header
     *  - display : 1 | 0
     *  - url : url du widget "alias.widget.criteo.com/pjl/"
     *  - code_se : xxxxxxx
     *  - code_tr : xxxxxxx
     */
    static public function init($config = array()) {
        self::$config = $config;
    }

    /**
     * Check if criteo is initialized.
     * If not trigger a warning error
     */
    static protected function triggerErrorIfNotInit()
    {
        if (is_null(self::$config)) {
            trigger_error("Criteo n'est pas initailisé", E_USER_WARNING);
        }
    }

    /**
     * @param array $param
     */
    static public function panier($param=array()) {

        self::triggerErrorIfNotInit();

        $out = "";

        $list = "";
        $i = 1;

        foreach ($param['extra']['produits'] as $p) {
            if(!empty($p['produit_attribut_id'])) {
                $list.="&i" . $i . "=" . $p['produit_id'].'ATT'.$p['produit_attribut_id'];
            }
            else {
                $list.="&i" . $i . "=" . $p['produit_id'];
            }
            $list.="&p" . $i . "=" . $p['prix_ttc'];
            $list.="&q" . $i . "=" . $p['qte'];
            $i++;
        }


        if (self::$config['display']) {

            $out = "<script type=\"text/javascript\" src=\"//static.criteo.net/criteo_ld3.js\"></script>\n";

            //cto basket tag
            $out.= "<div id=\"cto_tr_".self::$config['code_tr']."_ac\" style=\"display:none\">\n";
            $out.= "<div class=\"ctoWidgetServer\">//".self::$config['url']."</div>\n";
            $out.= "<div class=\"ctoDataType\">transaction</div>\n";
            $out.= "<div class=\"ctoParams\">wi=".self::$config['code_tr']."&s=0" . $list . "</div>\n";
            $out.= "</div>\n";

        }

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function listing($param=array()) {

        self::triggerErrorIfNotInit();

        $out="";

        if (self::$config['display']) {

            $list = "";
            $i = 1;
            foreach ($param['extra'] as $p) {
                if($i>3)break;
                $list.="&i" . $i . "=" . $p['produit_id'];
                $i++;
            }

            $out = '<script type="text/javascript" src="//static.criteo.net/criteo_ld3.js"></script>';

            $out.= "<div id=\"cto_se_".self::$config['code_se']."_ac\" style=\"display:none\">";
            $out.= "<div class=\"ctoWidgetServer\">//".self::$config['url']."</div>";
            $out.= "<div class=\"ctoDataType\">sendEvent</div>";
            $out.= "<div class=\"ctoParams\">wi=".self::$config['code_se']."&pt1=3" . $list . "</div>";
            $out.= "</div>";


        }


        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function homepage($param=array()) {

        self::triggerErrorIfNotInit();

        $out = "";

        if (self::$config['display']) {
            $out = "<script type=\"text/javascript\" src=\"//static.criteo.net/criteo_ld3.js\"></script>\n";

            //cto home tag
            $out.= "<script type='text/javascript'>\n";
            $out.= "document.write('<div id=\"cto_se_".self::$config['code_se']."_ac\" style=\"display:none\">');\n";
            $out.= "document.write('<div class=\"ctoWidgetServer\">\/\/".self::$config['url']."<\/div>');\n";
            $out.= "document.write('<div class=\"ctoDataType\">sendEvent<\/div>');\n";
            $out.= "document.write('<div class=\"ctoParams\">wi=".self::$config['code_se']."&pt1=0&pt2=1<\/div>');\n";
            $out.= "document.write('<\/div>');\n";
            $out.= "</script>\n";
        }

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function produit($param=array()) {

        self::triggerErrorIfNotInit();

        $out = "";

        if (self::$config['display']) {
            $out = "<script type=\"text/javascript\" src=\"//static.criteo.net/criteo_ld3.js\"></script>\n";

            //cto product tag
            $out.="<script type='text/javascript'>\n";
            $out.="document.write('<div id=\"cto_se_".self::$config['code_se']."_ac\" style=\"display:none\">');\n";
            $out.="document.write('<div class=\"ctoWidgetServer\">\/\/".self::$config['url']."<\/div>');\n";
            $out.="document.write('<div class=\"ctoDataType\">sendEvent<\/div>');\n";
            if(!empty($param['produit_attribut_id'])) {
                $out.="document.write('<div class=\"ctoParams\">wi=".self::$config['code_se']."&pt1=2&i=" . $param['produit_id'] . "ATT".$param['produit_attribut_id']."<\/div>');\n";
            }
            else {
                $out.="document.write('<div class=\"ctoParams\">wi=".self::$config['code_se']."&pt1=2&i=" . $param['produit_id'] . "<\/div>');\n";
            }
            $out.="document.write('<\/div>');\n";
            $out.="</script>\n";

        }


        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function paiement($param=array()) {

        self::triggerErrorIfNotInit();

        $out="";


        if (self::$config['display']) {

            $list = "";
            $i = 1;

            foreach ($param['extra']['produits'] as $p) {
                if(!empty($p['produit_attribut_id'])) {
                    $list.="&i" . $i . "=" . $p['produit_id'].'ATT'.$p['produit_attribut_id'];
                }
                else {
                    $list.="&i" . $i . "=" . $p['produit_id'];
                }
                $list.="&p" . $i . "=" . $p['prix_ttc'];
                $list.="&q" . $i . "=" . $p['qte'];
                $i++;
            }



            $out = '<script type="text/javascript" src="//static.criteo.net/criteo_ld3.js"></script>';
            //cto sales tag
            $out.="<script type='text/javascript'>";
            $out.= "document.write('<div id=\"cto_tr_".self::$config['code_tr']."_ac\" style=\"display:none\">');";
            $out.= "document.write('<div class=\"ctoWidgetServer\">\/\/sslwidget.criteo.com/psu/<\/div>');";
            $out.= "document.write('<div class=\"ctoDataType\">transaction<\/div>');";
            $out.= "document.write('<div class=\"ctoParams\">wi=".self::$config['code_tr']."&t=" . $param['extra']['commande_id'] . "&s=1" . $list . "<\/div>');";
            $out.= "document.write('<\/div>');";
            $out.="</script>";

        }

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

}
